/**
 * Account data export
 * 
 * @author Pierre Hubert
 */

import { User } from "./User";
import { Post } from "./Post";
import { Comment } from "./Comment";
import { UserLike } from "./UserLike";
import { SurveyResponse } from "./SurveyResponse";
import { Movie } from "./Movie";
import { ConversationMessage } from "./ConversationMessage";
import { Conversation } from "./Conversation";
import { Friend } from "./Friend";

export interface AccountExportBuilder {
	userID: number;
	userInfo: User;
	postsList: Post[];
	comments: Comment[];
	likes: UserLike[];
	surveyResponses: SurveyResponse[];
	movies: Movie[];
	allConversationMessages: ConversationMessage[];
	conversations: Conversation[];
	conversationsMessages: Map<number, ConversationMessage[]>;
	friendsList: Friend[];
}

export class AccountExport implements AccountExportBuilder {
	userID: number;
	userInfo: User;
	postsList: Post[];
	comments: Comment[];
	likes: UserLike[];
	surveyResponses: SurveyResponse[];
	movies: Movie[];
	allConversationMessages: ConversationMessage[];
	conversations: Conversation[];
	conversationsMessages: Map<number, ConversationMessage[]>;
	friendsList: Friend[];

	public constructor(info: AccountExportBuilder) {
		for (const key in info) {
			if (info.hasOwnProperty(key))
				this[key] = info[key];
		}
	}
}